/* Макросы и переменные сделаны в виде структуры для удобства сворачивания. */

struct{ // Переменные. Обязательно инициализировать перед использованием.
	int cnt;
}vars;

struct{ // Макросы.
	#define SPIDER_ADDR 1
	#define OUTPUT_1	1
	#define OUTPUT_2	2
	#define OUTPUT_3	3
	#define OUTPUT_4	4
	#define INPUT_1		10001
	#define INPUT_2		10002
	#define INPUT_3		10003
	#define INPUT_4		10004
	#define NULL  ((void*)0x00000000)
}defs;

/******************************************************************************************
* Прототип функции main не менять, закрывающую скобку '}' в конце тела функции не ставить *
******************************************************************************************/
void main(
	int *pTmpInt, // Системные переменные, не использовать
	float *pTmpFlt, // Системные переменные, не использовать
  	int (*pInts), /* Указатель на массив целочисленных переменных, доступны через ModBus, 32 бит */
	float (*pFloats), /* Указатель на массив переменных с плавающей точкой, доступны через ModBus, 32 бит */
	int (pKeyH), /* Старшие 32 бита ключа 1-wire */
	int (pKeyL), /* Младшие 32 бита ключа 1-wire */
	int (*pGetNodeVar)( unsigned short dev_addr, unsigned short reg_addr ), /* Чтение переменной из узла  */
	int (*pSetNodeVar)( unsigned short dev_addr, unsigned short reg_addr, unsigned short val ), /* Запись значения переменной в узел */
	int (*pGetTimer)( unsigned short TimerNum ), /* Возвращает значение таймера, (-1) -> выключен */
	int (*pSetTimer)( unsigned short TimerNum, int TimerVal ), /* Возводит таймер, (-1) -> выключен */
	int (*pReceiveSMS)( const char *smsnum, const char *smstext, int *parInt, float *parFlt ),/* Receive SMS */
	int (*pSendSMS)( const char *smsnum, const char *smstext, int *parInt, float *parFlt ), /* Send sms */
	int (*pSendCom2)( const char *TxData, unsigned short TxLen, const char *RxData, unsigned short RxLen), /* Send data over Com2 */
	int (*pTimeCmp)( unsigned char date, unsigned char month, unsigned char year, unsigned char hour, unsigned char minute, unsigned char second, unsigned char day, unsigned char act ), /* Сравнивает время *//* action ( 1'==', 2'!=', 3'>', 4'<' */
	float (*pSinf)(float _X),
	float (*pCosf)(float _X),
	float (*pLogf)(float _X),
	float (*pExpf)(float _X),
	float (*pPowf)(float _X1, float _X2),
	float (*pSqrtf)(float _X)
)
{
//------------------------------------- // определения и переменные
#define varDelitToSeconds pInts[1]		// делитель на 100, до секунд
#define varYear pInts[2]				// переменные для вычисления даты и времени
#define varMon pInts[3]
#define varDay pInts[4]
#define varHour pInts[5]
#define varMin pInts[6]
#define varSec pInts[7]
//------------------------------------- // вычисление даты и времени
if (++varDelitToSeconds>=100)
{
	varDelitToSeconds=0;
	for(varYear=0;varYear<=99;varYear++) if(pTimeCmp(0xFF,0xFF,varYear,0xFF,0xFF,0xFF,0xFF,1)==0) break;
	for(varMon=1;varMon<=12;varMon++) if(pTimeCmp(0xFF,varMon,0xFF,0xFF,0xFF,0xFF,0xFF,1)==0) break;
	for(varDay=1;varDay<=31;varDay++) if(pTimeCmp(varDay,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,1)==0) break;
	for(varHour=0;varHour<=23;varHour++) if(pTimeCmp(0xFF,0xFF,0xFF,varHour,0xFF,0xFF,0xFF,1)==0) break;
	for(varMin=0;varMin<=59;varMin++) if(pTimeCmp(0xFF,0xFF,0xFF,0xFF,varMin,0xFF,0xFF,1)==0) break;
	for(varSec=0;varSec<=59;varSec++) if(pTimeCmp(0xFF,0xFF,0xFF,0xFF,0xFF,varSec,0xFF,1)==0) break;
}

}
